--ver: 3.26
AFriend = LibStub("AceAddon-3.0"):NewAddon("AFriend", "AceHook-3.0");
local Afriends, Aguilds = LibStub("LibFriends-1.0"), LibStub("LibGuild-1.0");
local AFriend = AFriend;
local AFriendButtons = {};
local AfriendMenu = {};
local AButtons = {"Add_Friend", "Remove_Friend", "Add_Guild", "Remove_Guild"};
local AButtonTxt = {"Add Friend", "Remove Friend", "Invite to Guild", "Remove from Guild"};
local AToolTips = {"Add player to your friends list", "Remove player from your friends list", "Invite this player to join your guild", "Remove this player from your guild"};
local redColor = {r=1.0, g=0, b=0};
local greenColor = {r=0, g=1.0, b=0};
local AColors = {greenColor, redColor, greenColor, redColor};
local format, gsub, ipairs = format, gsub, ipairs;
local IsInGuild, CanGuildInvite  = IsInGuild, CanGuildInvite;
local UnitGUID, UnitCanCooperate = UnitGUID, UnitCanCooperate;
local frameTypes = {["FRIEND"]=1,["PLAYER"]=1,["PARTY"]=1,["RAID_PLAYER"]=1,["RAID"]=1,["PET"]=false,["SELF"]=false};

function AFriend:OnEnable()
	for i,v in ipairs(AButtons) do
		AFriendButtons[v] = {text=format("%s", AButtonTxt[i]), dist=0, color=AColors[i], tooltipText=AToolTips[i]};
		AfriendMenu[i] = v;
	end
	self:SecureHook("UnitPopup_ShowMenu");
end

local function AFriend_Button_Onclick(self, info)
	assert(info);
	local button = info.button; assert(button);
	local name = info.name or UnitName(info.unit); assert(name);
	if button == "Add_Friend" then AddFriend(name);
	elseif button == "Remove_Friend" then RemoveFriend(name);
	elseif button == "Add_Guild" then GuildInvite(name);
	elseif button == "Remove_Guild" then GuildUninvite(name); end
end

function AFriend:UnitPopup_ShowMenu(dropdownMenu, which, unit, name, userData)
	local thisName = name or UnitName(unit);
	which = gsub(which, "PB4_", "");
	if not frameTypes[which] then return; end
	if (which ~= "FRIEND") and (not UnitCanCooperate("player", unit) or UnitGUID(unit) == UnitGUID("player")) then return; end
	if which == "FRIEND" and thisName == UnitName("player") then return; end
	if (UIDROPDOWNMENU_MENU_LEVEL > 1) then return; end
	local info = UIDropDownMenu_CreateInfo();
	for _, v in ipairs(AfriendMenu) do
		info.text=AFriendButtons[v].text;
		info.value=v;
		info.owner=which;
		info.func=AFriend_Button_Onclick;
		info.notCheckable=1;
		color = AFriendButtons[v].color;
		if color then info.colorCode = format("|cFF%02x%02x%02x", color.r*255, color.g*255, color.b*255);
		else info.colorCode = nil; end
		info.arg1 = {["button"]=v, ["unit"]=unit, ["name"]=name};
		info.tooltipTitle = AFriendButtons[v].text;
		info.tooltipText = AFriendButtons[v].tooltipText;
		if IsInGuild() and CanGuildInvite() then
			if v == "Remove_Guild" and Aguilds:HasMember(thisName) ~= nil then UIDropDownMenu_AddButton(info);
			elseif v == "Add_Guild" and Aguilds:HasMember(thisName) == nil then UIDropDownMenu_AddButton(info); end
		end
		if v == "Remove_Friend" and Afriends:HasFriend(thisName) then UIDropDownMenu_AddButton(info);
		elseif v == "Add_Friend" and not Afriends:HasFriend(thisName) then UIDropDownMenu_AddButton(info); end
	end
end